import { ref as $, reactive as oe, computed as fe, toRefs as Ee, defineComponent as _e, onMounted as he, resolveComponent as _, openBlock as i, createBlock as g, withCtx as o, createElementVNode as G, renderSlot as H, createVNode as s, unref as e, createElementBlock as L, Fragment as K, renderList as j, mergeProps as A, withModifiers as ge, createTextVNode as q, toDisplayString as te, createCommentVNode as z, resolveDirective as we, withDirectives as ve, createSlots as Re, resolveDynamicComponent as Oe, normalizeProps as Te, guardReactiveProps as $e, withKeys as Ue, vShow as xe, isRef as Le } from "vue";
import { ElMessage as Ae, ElMessageBox as De, ElNotification as Ne, ElButton as ee, ElButtonGroup as ze, ElDialog as Ke } from "element-plus";
import { useRoute as qe } from "vue-router";
const U = $({
  debug: !1,
  mainMaxHeight: 700,
  isAfterMountQuery: !1,
  isOpenSearchForm: !1,
  Form_LabelWidth: 120,
  Dialog_Width: 800,
  Dialog_isFullscreen: !1,
  Dialog_isCloseOnPressEscape: !0,
  Dialog_isCloseOnClickModal: !1,
  Dialog_isFooterButton: !0,
  Table_isOpenIndex: !0,
  Table_isOpenMultipleSelection: !1,
  Table_isOpenExpand: !0,
  Table_ExpandColumn: 4,
  Table_MenuWidth: 200,
  Table_MenuAlign: "left",
  Page_PageSizes: [10, 20, 50, 100],
  Page_PageParams: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  Page_Layout: "->,total, sizes, prev, pager, next, jumper",
  Page_isHideOnSinglePage: !1,
  ApiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
}), d = $({
  CompRef: {},
  Mode: "add",
  DialogVisible: !1,
  tableLoading: !1,
  submitLoading: !1,
  DialogVisibleFooterButton: !0,
  ElementArrs: { filter: {}, editor: {}, column: {}, columns: {} },
  tableColumn: [],
  originalData: [],
  tableData: [],
  multipleSelection: [],
  uploadFiles: [],
  initSearchModel: {},
  initEditModel: {},
  searchFormValue: {},
  searchModel: {},
  editFormValue: {},
  editModel: {}
}), Se = $({});
function ae(r) {
  let p;
  try {
    p = Array.isArray(r) ? [] : {}, r === null && (p = null);
  } catch {
    p = {};
  }
  for (const c in r)
    typeof r[c] == "object" ? p[c] = ae(r[c]) : p[c] = r[c];
  return p;
}
function Fe(...r) {
  function p(a) {
    return typeof a == "object" && Object.prototype.toString.call(a) === "[object Object]";
  }
  let c = arguments.length, b = arguments[0];
  p(b) || (b = {});
  for (let a = 1; a < c; a++) {
    let C = arguments[a];
    if (p(C))
      for (let E in C)
        E === "__proto__" || b === C[E] || b.hasOwnProperty(E) && (p(C[E]) ? b[E] = Fe(b[E], C[E]) : b[E] = C[E]);
  }
  return b;
}
function Ie(r, p) {
  let c = {}, b = Object.getOwnPropertyNames(r), a = Object.getOwnPropertyNames(p);
  return b.length === a.length && b.forEach((C) => {
    r[C] !== p[C] && (c[C] = p[C]);
  }), c;
}
const le = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeBatchDeteleHandler: "beforeBatchDeteleHandler",
  afterBatchDeteleHandler: "afterBatchDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function je(r = { debug: !1 }) {
  const p = oe({
    hooks: {}
  });
  return Object.keys(r).forEach((b) => {
    b !== "debug" && (p.hooks[b] = r[b]);
  }), {
    hookHandler: (b, a) => {
      let C = !1;
      try {
        r.debug && (console.group("DeBug\uFF1A", b), console.table(a.Data), console.groupEnd()), C = p.hooks[b](a);
      } catch {
        C = !0;
      }
      return C;
    }
  };
}
let R = {};
const ue = $(), We = (r) => {
  ue.value = r.CrudRequest, U.value = Fe(U.value, r), ce("\u3010\u521D\u59CB\u5316Options\u3011", r), R = { ...U.value };
}, Qe = (r) => {
  Se.value = r, Je(r.source), U.value = Fe(U.value, r), ce("UseCrudStates\u4F20\u53C2\u3010props\u3011", r), ce("\u3010DefParams\u3011", U.value), ce("\u3010CrudStates\u3011", d.value);
};
function me() {
  return { ...Ee(U.value) };
}
function O() {
  return { ...Ee(d.value) };
}
function Me() {
  return { ...Ee(Se.value) };
}
const Ve = () => {
  const r = Se.value, p = (t) => {
    let n = {};
    return r.rowKey && (n[r.rowKey] = t[r.rowKey]), r.rowKeys && r.rowKeys.forEach((P) => {
      n[P] = t[P];
    }), n;
  }, { hookHandler: c } = je(r.hooks);
  function b() {
    d.value.tableLoading = !0;
    const t = oe({ ...d.value.initSearchModel, ...d.value.searchModel });
    for (const n in t)
      typeof t[n] == "string" && (t[n] = t[n].trim(), t[n] === "" && (t[n] = void 0)), t[n] === null && (t[n] = void 0);
    !c(le.beforeQueryHandler, { CrudState: d.value, Data: t }) || ue.value({
      url: r.url,
      name: U.value.ApiName.query,
      data: {
        pagenum: U.value.Page_PageParams.current,
        pagesize: U.value.Page_PageParams.pageSize,
        ...t
      }
    }).then((n) => {
      const { data: P, page: B } = n;
      setTimeout(() => {
        a(P, t), U.value.Page_PageParams.total = B.total, d.value.tableLoading = !1;
      }, 50);
    }).catch(() => {
      d.value.tableLoading = !1;
    });
  }
  const a = (t, n) => {
    Object.keys(n).filter((B) => n[B] != null).length == 0 && (d.value.originalData = t), d.value.originalData = ae(t), c(le.afterQueryHandler, { CrudState: d.value, Data: t }) && (d.value.tableData = ae(t));
  };
  function C() {
    d.value.editModel = ae(d.value.initEditModel);
    const t = oe({ ...d.value.editModel });
    !c(le.beforeAddHandler, { CrudState: d.value, Data: t }) || (d.value.Mode = "add", d.value.DialogVisible = !0);
  }
  const E = (t) => {
    const n = oe({
      ...t
    });
    if (!c(le.beforeEditHandler, { CrudState: d.value, Data: n }))
      return;
    const P = ae(n);
    Object.keys(P).forEach((B) => {
      d.value.editModel[B] = P[B], d.value.editFormValue[B] = P[B];
    }), d.value.Mode = "edit", d.value.DialogVisible = !0;
  }, v = async (t) => {
    !t || await t.validate((n) => {
      if (n) {
        const P = oe({
          ...d.value.editModel
        });
        if (!c(le.beforeSubmitHandler, { CrudState: d.value, Data: P }))
          return;
        d.value.Mode === "add" ? S(P) : w(P);
      }
    });
  }, S = (t) => {
    d.value.submitLoading = !0;
    let n = t;
    t.FormData instanceof FormData && (n = t.FormData), ue.value({ url: r.url, name: U.value.ApiName.add, data: n }).then(() => {
      d.value.DialogVisible = !1, pe("\u65B0\u589E\u6210\u529F"), b(), d.value.submitLoading = !1;
    }).catch(() => {
      d.value.submitLoading = !1;
    });
  }, w = (t) => {
    d.value.submitLoading = !1;
    let n = t;
    if (t.FormData instanceof FormData)
      n = t.FormData;
    else {
      const P = Ie(d.value.editModel, n);
      if (JSON.stringify(P) === "{}")
        return d.value.submitLoading = !1, Ae({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
      n = {
        ...p(t),
        ...P
      };
    }
    ue.value({ url: r.url, name: U.value.ApiName.edit, data: n }).then(() => {
      d.value.DialogVisible = !1, pe("\u7F16\u8F91\u6210\u529F"), b(), d.value.submitLoading = !1;
    }).catch(() => {
      d.value.submitLoading = !1;
    });
  };
  return {
    queryRecord: b,
    addRecord: C,
    editRecord: E,
    handleSubmit: v,
    delFlag: (t) => {
      De.confirm(`\u786E\u5B9A\u8981 \u201C${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = oe({
          ...p(t),
          deleteFlag: t.deleteFlag == 0 ? 1 : 0
        });
        !c(le.beforedisabledHandler, { CrudState: d.value, Data: n }) || ue.value({
          url: r.url,
          name: U.value.ApiName.deleteFlag,
          data: n
        }).then(() => {
          pe(`\u6570\u636E${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), b();
        });
      }).catch(() => {
      });
    },
    deleteRecord: (t) => {
      De.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = oe({
          ...p(t)
        });
        !c(le.beforeDeteleHandler, { CrudState: d.value, Data: n }) || ue.value({
          url: r.url,
          name: U.value.ApiName.delete,
          data: n
        }).then(() => {
          pe("\u5220\u9664\u6210\u529F"), b();
        });
      }).catch(() => {
      });
    },
    deleteMulRecord: () => {
      const t = d.value.multipleSelection.map((n) => n[r.rowKey]);
      De.confirm(`\u786E\u5B9A\u8981\u5220\u9664\u8FD9 ${t.length} \u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = oe({
          [r.rowKey]: t,
          selection: d.value.multipleSelection
        });
        !c(le.beforeBatchDeteleHandler, { CrudState: d.value, Data: n }) || ue.value({
          url: r.url,
          name: U.value.ApiName.remove,
          data: n
        }).then(() => {
          pe("\u6279\u91CF\u5220\u9664\u6210\u529F"), d.value.multipleSelection = [], d.value.CompRef.TableRef.clearSelection(), b();
        });
      }).catch(() => {
      });
    }
  };
};
function ce(...r) {
  U.value.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...r);
}
const Je = (r) => {
  const { filter: p, editor: c, column: b, columns: a } = r;
  let C = {};
  p.forEach((v) => {
    try {
      C[v] = a[v].searchDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", v);
    }
    d.value.ElementArrs.filter[v] = a[v];
  }), d.value.initSearchModel = ae(C), d.value.searchModel = ae(d.value.initSearchModel);
  let E = {};
  c.forEach((v) => {
    try {
      E[v] = a[v].addDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", v);
    }
    d.value.ElementArrs.editor[v] = a[v];
  }), d.value.initEditModel = ae(E), b.forEach((v) => {
    d.value.ElementArrs.column[v] = a[v];
  }), d.value.ElementArrs.columns = a;
};
fe(() => {
  let r = [];
  for (const p in d.value.ElementArrs.editor)
    Object.prototype.hasOwnProperty.call(d.value.ElementArrs.editor, p) && d.value.ElementArrs.editor[p].type === "el-upload" && r.push(p);
  return r;
});
const pe = (r, p = "success") => {
  Ne({
    title: r,
    type: p,
    offset: 70,
    duration: 2500
  });
}, Ge = /* @__PURE__ */ _e({
  __name: "crud_SearchForm",
  setup(r) {
    const p = $(), { Form_LabelWidth: c } = me(), {
      CompRef: b,
      searchModel: a,
      ElementArrs: {
        value: { filter: C }
      }
    } = O();
    he(() => {
      b.value.SearchFormRef = p.value;
    });
    const E = (S) => {
      var w, V;
      return S.range ? (w = S.formProps) != null && w.type ? S.formProps.type + "range" : "daterange" : (V = S.formProps) != null && V.type ? S.formProps.type : "date";
    }, v = (S, w, V) => {
      a.value[w] === V ? a.value[w] = void 0 : a.value[w] = S.formProps.options[V].value;
    };
    return (S, w) => {
      const V = _("el-input"), N = _("el-form-item"), x = _("el-col"), t = _("el-input-number"), n = _("el-option"), P = _("el-select"), B = _("el-date-picker"), T = _("el-time-picker"), ne = _("el-radio"), re = _("el-radio-button"), I = _("el-radio-group"), X = _("el-row"), W = _("el-form"), Y = _("el-collapse-transition");
      return i(), g(Y, null, {
        default: o(() => [
          G("div", null, [
            H(S.$slots, "search-form", {}, void 0, !0),
            s(W, {
              ref_key: "SearchFormRef",
              ref: p,
              model: e(a),
              "label-width": e(c)
            }, {
              default: o(() => [
                s(X, null, {
                  default: o(() => [
                    H(S.$slots, "search-form-top", {}, void 0, !0),
                    (i(!0), L(K, null, j(e(C), (u, F) => {
                      var Q;
                      return i(), L(K, null, [
                        u.type === "el-input" ? (i(), g(x, {
                          key: 0,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(N, {
                              label: u.label,
                              prop: F
                            }, {
                              default: o(() => [
                                s(V, A({
                                  modelValue: e(a)[F],
                                  "onUpdate:modelValue": (h) => e(a)[F] = h,
                                  clearable: "",
                                  placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-input-number" ? (i(), g(x, {
                          key: 1,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(N, {
                              label: u.label,
                              prop: F
                            }, {
                              default: o(() => [
                                s(t, A({
                                  modelValue: e(a)[F],
                                  "onUpdate:modelValue": (h) => e(a)[F] = h,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-select" ? (i(), g(x, {
                          key: 2,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(N, {
                              label: u.label,
                              prop: F
                            }, {
                              default: o(() => [
                                s(P, A({
                                  style: { width: "100%" },
                                  modelValue: e(a)[F],
                                  "onUpdate:modelValue": (h) => e(a)[F] = h,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9"
                                }, u.formProps), {
                                  default: o(() => [
                                    (i(!0), L(K, null, j(u.formProps.options, (h) => (i(), g(n, {
                                      key: h.value,
                                      label: h.label,
                                      value: h.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" && !E(u).includes("range") ? (i(), g(x, {
                          key: 3,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(N, {
                              label: u.label,
                              prop: F
                            }, {
                              default: o(() => [
                                s(B, A({
                                  modelValue: e(a)[F],
                                  "onUpdate:modelValue": (h) => e(a)[F] = h,
                                  "range-separator": "\u81F3",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" ? (i(), g(x, {
                          key: 4,
                          span: u.span ? u.span : 12
                        }, {
                          default: o(() => [
                            s(N, {
                              label: u.label,
                              prop: F
                            }, {
                              default: o(() => [
                                s(B, A({
                                  modelValue: e(a)[F],
                                  "onUpdate:modelValue": (h) => e(a)[F] = h,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, {
                                  type: E(u)
                                }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" && !((Q = u.formProps) != null && Q.isRange) && !u.range ? (i(), g(x, {
                          key: 5,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(N, {
                              label: u.label,
                              prop: F
                            }, {
                              default: o(() => [
                                s(T, A({
                                  style: { width: "100%" },
                                  modelValue: e(a)[F],
                                  "onUpdate:modelValue": (h) => e(a)[F] = h,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" ? (i(), g(x, {
                          key: 6,
                          span: u.span ? u.span : 12
                        }, {
                          default: o(() => [
                            s(N, {
                              label: u.label,
                              prop: F
                            }, {
                              default: o(() => [
                                s(T, A({
                                  style: { width: "100%" },
                                  modelValue: e(a)[F],
                                  "onUpdate:modelValue": (h) => e(a)[F] = h,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, { "is-range": "" }), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-radio-group" ? (i(), g(x, {
                          key: 7,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(N, {
                              label: u.label,
                              prop: F
                            }, {
                              default: o(() => [
                                s(I, A({
                                  modelValue: e(a)[F],
                                  "onUpdate:modelValue": (h) => e(a)[F] = h
                                }, u.formProps), {
                                  default: o(() => [
                                    u.formProps.button ? z("", !0) : (i(!0), L(K, { key: 0 }, j(u.formProps.options, (h) => (i(), g(ne, A({
                                      key: h.value,
                                      label: h.value,
                                      onClick: ge((Z) => v(u, F, h.value), ["prevent"])
                                    }, u.formProps), {
                                      default: o(() => [
                                        q(te(h.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    u.formProps.button ? (i(!0), L(K, { key: 1 }, j(u.formProps.options, (h) => (i(), g(re, A({
                                      key: h.value,
                                      label: h.value,
                                      onClick: ge((Z) => v(u, F, h.value), ["prevent"])
                                    }, u.formProps), {
                                      default: o(() => [
                                        q(te(h.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64);
                    }), 256)),
                    H(S.$slots, "search-form-bottom", {}, void 0, !0)
                  ]),
                  _: 3
                })
              ]),
              _: 3
            }, 8, ["model", "label-width"])
          ])
        ]),
        _: 3
      });
    };
  }
});
const Be = (r, p) => {
  const c = r.__vccOpts || r;
  for (const [b, a] of p)
    c[b] = a;
  return c;
}, Xe = /* @__PURE__ */ Be(Ge, [["__scopeId", "data-v-394e11ba"]]), Ye = { class: "edit" }, Ze = { class: "edit_form" }, el = /* @__PURE__ */ _e({
  __name: "crud_EditForm",
  props: {
    height: Number
  },
  setup(r) {
    const p = $(), { Form_LabelWidth: c } = me(), {
      CompRef: b,
      editModel: a,
      Mode: C,
      ElementArrs: {
        value: { editor: E }
      },
      uploadFiles: v
    } = O();
    he(() => {
      b.value.EditFormRef = p.value;
    });
    const S = fe(() => {
      let t = {};
      return Me().source.value.editor.forEach((n) => {
        typeof E[n].visible == "function" ? E[n].visible(O(), C.value) && (t[n] = E[n]) : t[n] = E[n];
      }), t;
    }), w = ({ showFileList: t }) => {
      if (t)
        return !1;
      if (v.value[0])
        return URL.createObjectURL(v.value[0]);
    }, V = (t) => typeof t.disabled == "function" ? t.disabled(O(), C.value) : !1, N = (t) => {
      let n = { ...t };
      return Object.keys(n).forEach((P) => {
        typeof n[P] == "function" && (n[P] = n[P].bind(this, O()));
      }), n;
    }, x = (t, n, P) => {
      a.value[n] === P ? a.value[n] = void 0 : a.value[n] = t.formProps.options[P].value;
    };
    return (t, n) => {
      const P = _("el-input"), B = _("el-form-item"), T = _("el-col"), ne = _("el-input-number"), re = _("el-option"), I = _("el-select"), X = _("el-date-picker"), W = _("el-time-picker"), Y = _("el-cascader"), u = _("el-button"), F = _("el-image"), Q = _("plus"), h = _("el-icon"), Z = _("el-upload"), se = _("el-radio"), de = _("el-radio-button"), ie = _("el-radio-group"), m = _("el-row"), D = _("el-form"), M = _("el-scrollbar");
      return i(), L("div", Ye, [
        s(M, {
          height: r.height,
          "max-height": r.height
        }, {
          default: o(() => [
            G("div", Ze, [
              H(t.$slots, "edit-form", { editModel: e(a) }, void 0, !0),
              s(D, {
                ref_key: "EditFormRef",
                ref: p,
                model: e(a),
                "label-width": e(c)
              }, {
                default: o(() => [
                  s(m, null, {
                    default: o(() => [
                      H(t.$slots, "edit-form-top", { editModel: e(a) }, void 0, !0),
                      (i(!0), L(K, null, j(e(S), (l, y) => (i(), L(K, { key: y }, [
                        l.type === "el-input" ? (i(), g(T, {
                          key: 0,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(B, {
                              label: l.label,
                              prop: y,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(P, A({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (f) => e(a)[y] = f,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-input-number" ? (i(), g(T, {
                          key: 1,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(B, {
                              label: l.label,
                              prop: y,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(ne, A({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (f) => e(a)[y] = f,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-select" ? (i(), g(T, {
                          key: 2,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(B, {
                              label: l.label,
                              prop: y,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(I, A({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (f) => e(a)[y] = f,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  disabled: V(l)
                                }, l.formProps), {
                                  default: o(() => [
                                    (i(!0), L(K, null, j(l.formProps.options, (f) => (i(), g(re, {
                                      key: f.value,
                                      label: f.label,
                                      value: f.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-date-picker" ? (i(), g(T, {
                          key: 3,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(B, {
                              label: l.label,
                              prop: y,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(X, A({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (f) => e(a)[y] = f,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-time-picker" ? (i(), g(T, {
                          key: 4,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(B, {
                              label: l.label,
                              prop: y,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(W, A({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (f) => e(a)[y] = f,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-cascader" ? (i(), g(T, {
                          key: 5,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(B, {
                              label: l.label,
                              prop: y,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(Y, A({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (f) => e(a)[y] = f,
                                  props: l.formProps.props,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  "show-all-levels": !1,
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-upload" ? (i(), g(T, {
                          key: 6,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(B, {
                              label: l.label,
                              prop: y,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(Z, A({
                                  style: { width: "100%" },
                                  ref_for: !0,
                                  ref: y + "UploadRef",
                                  action: ""
                                }, N(l.formProps)), {
                                  default: o(() => {
                                    var f;
                                    return [
                                      ((f = l.formProps) == null ? void 0 : f.listType) !== "picture-card" ? (i(), g(u, {
                                        key: 0,
                                        type: "primary"
                                      }, {
                                        default: o(() => [
                                          q(te(l.formProps.butName || "\u70B9\u51FB\u4E0A\u4F20\u6587\u4EF6"), 1)
                                        ]),
                                        _: 2
                                      }, 1024)) : z("", !0),
                                      l.formProps.listType === "picture-card" && w(l.formProps) ? (i(), g(F, {
                                        key: 1,
                                        style: { width: "146px", height: "146px", "border-radius": "5px" },
                                        fit: "contain",
                                        src: w(l.formProps)
                                      }, null, 8, ["src"])) : z("", !0),
                                      l.formProps.listType == "picture-card" && !w(l.formProps) ? (i(), g(h, { key: 2 }, {
                                        default: o(() => [
                                          s(Q)
                                        ]),
                                        _: 1
                                      })) : z("", !0)
                                    ];
                                  }),
                                  _: 2
                                }, 1040)
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-radio-group" ? (i(), g(T, {
                          key: 7,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(B, {
                              label: l.label,
                              prop: y,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(ie, A({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (f) => e(a)[y] = f,
                                  disabled: V(l)
                                }, l.formProps), {
                                  default: o(() => [
                                    l.formProps.button ? z("", !0) : (i(!0), L(K, { key: 0 }, j(l.formProps.options, (f) => (i(), g(se, A({
                                      key: f.value,
                                      label: f.value,
                                      onClick: ge((ye) => x(l, y, f.value), ["prevent"])
                                    }, l.formProps), {
                                      default: o(() => [
                                        q(te(f.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    l.formProps.button ? (i(!0), L(K, { key: 1 }, j(l.formProps.options, (f) => (i(), g(de, A({
                                      key: f.value,
                                      label: f.value,
                                      onClick: ge((ye) => x(l, y, f.value), ["prevent"])
                                    }, l.formProps), {
                                      default: o(() => [
                                        q(te(f.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64))), 128)),
                      H(t.$slots, "edit-form-bottom", { editModel: e(a) }, void 0, !0)
                    ]),
                    _: 3
                  })
                ]),
                _: 3
              }, 8, ["model", "label-width"])
            ])
          ]),
          _: 3
        }, 8, ["height", "max-height"])
      ]);
    };
  }
});
const ll = /* @__PURE__ */ Be(el, [["__scopeId", "data-v-08532dff"]]), ol = { key: 1 }, al = /* @__PURE__ */ _e({
  __name: "crud_Table",
  props: { height: Number },
  emits: ["row-contextmenu"],
  setup(r, { emit: p }) {
    const c = $(), { Table_isOpenMultipleSelection: b, Table_isOpenIndex: a, Table_isOpenExpand: C, Table_ExpandColumn: E, Table_MenuAlign: v, Table_MenuWidth: S, Page_PageParams: w, Permission: V } = me(), {
      CompRef: N,
      tableData: x,
      tableLoading: t,
      ElementArrs: {
        value: { filter: n, column: P, columns: B }
      },
      searchModel: T,
      multipleSelection: ne
    } = O(), { rowKey: re, keyName: I, Table_Attributes: X } = Me(), { queryRecord: W, editRecord: Y, delFlag: u, deleteRecord: F } = Ve();
    he(() => {
      N.value.TableRef = c.value;
    });
    const Q = fe(() => {
      var m, D;
      return (((m = w == null ? void 0 : w.value) == null ? void 0 : m.current) - 1) * ((D = w == null ? void 0 : w.value) == null ? void 0 : D.pageSize) + 1;
    }), h = (m) => {
      ne.value = m;
    }, Z = (m, D, M, l) => {
      D.label && navigator.clipboard.writeText(M.innerText).then(() => {
        Ae.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, se = (m, D, M) => {
      M.preventDefault(), p("row-contextmenu", { row: m, column: D, event: M }, O());
    }, de = (m, D, M) => {
      if (D.formProps) {
        const l = D.formProps.options.findIndex((y) => y.value == m[M]);
        return l === -1 ? m[M] : D.formProps.options[l].label;
      } else
        return m[M];
    }, ie = (m, D) => {
      let M = { ...m };
      return Object.keys(M).forEach((l) => {
        typeof M[l] == "function" && (M[l] = M[l].call(this, O(), D));
      }), M;
    };
    return (m, D) => {
      const M = _("el-empty"), l = _("el-table-column"), y = _("el-descriptions-item"), f = _("el-descriptions"), ye = _("el-input"), Ce = _("el-button"), He = _("el-table"), ke = we("loading");
      return ve((i(), g(He, A({
        ref_key: "TableRef",
        ref: c,
        data: e(x),
        "row-key": e(re),
        height: r.height,
        onCellDblclick: Z,
        onSelectionChange: h,
        onRowContextmenu: se
      }, e(X)), {
        empty: o(() => [
          s(M, {
            "image-size": 80,
            description: "\u6682\u65E0\u6570\u636E"
          })
        ]),
        default: o(() => [
          e(b) ? (i(), g(l, {
            key: 0,
            type: "selection",
            "reserve-selection": "",
            width: 44
          })) : z("", !0),
          e(C) ? (i(), g(l, {
            key: 1,
            type: "expand",
            width: 55
          }, {
            default: o((k) => [
              s(f, {
                column: e(E),
                border: ""
              }, {
                default: o(() => [
                  (i(!0), L(K, null, j(e(B), (J, be) => (i(), L(K, { key: be }, [
                    J.hidden ? z("", !0) : (i(), g(y, {
                      key: 0,
                      label: J.label
                    }, {
                      default: o(() => [
                        q(te(de(k.row, J, be)), 1)
                      ]),
                      _: 2
                    }, 1032, ["label"]))
                  ], 64))), 128))
                ]),
                _: 2
              }, 1032, ["column"])
            ]),
            _: 1
          })) : z("", !0),
          e(a) ? (i(), g(l, {
            key: 2,
            label: "###",
            width: 55,
            "show-overflow-tooltip": ""
          }, {
            default: o(({ $index: k }) => [
              q(te(e(Q) + k), 1)
            ]),
            _: 1
          })) : z("", !0),
          (i(!0), L(K, null, j(e(P), (k, J) => (i(), g(l, A({
            key: J,
            align: k.align || "left",
            label: k.label,
            prop: J
          }, k.tableProps, { "show-overflow-tooltip": "" }), Re({ _: 2 }, [
            k.columnSlot ? {
              name: "default",
              fn: o((be) => [
                (i(), g(Oe(k.columnSlot.is), Te($e(ie(k.columnSlot, be))), null, 16))
              ])
            } : void 0
          ]), 1040, ["align", "label", "prop"]))), 128)),
          H(m.$slots, "table-column"),
          s(l, {
            align: e(v) || "left",
            width: e(S)
          }, {
            header: o(() => [
              e(I) ? (i(), g(ye, {
                key: 0,
                modelValue: e(T)[e(I)],
                "onUpdate:modelValue": D[0] || (D[0] = (k) => e(T)[e(I)] = k),
                placeholder: e(n)[e(I)].label + "\u6A21\u7CCA\u67E5\u627E",
                clearable: "",
                onKeyup: Ue(e(W), ["enter", "native"])
              }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : (i(), L("span", ol, "\u64CD\u4F5C"))
            ]),
            default: o((k) => [
              H(m.$slots, "menu-top", { scope: k }),
              s(Ce, {
                plain: "",
                type: k.row[e(V).deleteFlag] ? "danger" : "success",
                onClick: (J) => e(u)(k.row)
              }, {
                default: o(() => [
                  q(te(k.row[e(V).deleteFlag] ? "\u7981\u7528" : "\u542F\u7528"), 1)
                ]),
                _: 2
              }, 1032, ["type", "onClick"]),
              s(Ce, {
                plain: "",
                type: "primary",
                icon: "edit",
                onClick: (J) => e(Y)(k.row)
              }, null, 8, ["onClick"]),
              s(Ce, {
                plain: "",
                type: "danger",
                icon: "delete",
                onClick: (J) => e(F)(k.row)
              }, null, 8, ["onClick"]),
              H(m.$slots, "menu-bottom", { scope: k })
            ]),
            _: 3
          }, 8, ["align", "width"])
        ]),
        _: 3
      }, 16, ["data", "row-key", "height"])), [
        [ke, e(t)]
      ]);
    };
  }
}), tl = /* @__PURE__ */ _e({
  __name: "crud_Pagination",
  setup(r) {
    const { Page_PageSizes: p, Page_PageParams: c, Page_Layout: b, Page_isHideOnSinglePage: a } = me(), { queryRecord: C } = Ve(), E = (S) => {
      c.value.pageSize = S, C();
    }, v = (S) => {
      c.value.current = S, c.value.current != null && C();
    };
    return (S, w) => {
      const V = _("el-pagination");
      return i(), g(V, {
        "hide-on-single-page": e(a),
        "current-page": e(c).current,
        "page-size": e(c).pageSize,
        "page-sizes": e(p),
        background: "",
        layout: e(b),
        total: e(c).total,
        onSizeChange: E,
        onCurrentChange: v
      }, null, 8, ["hide-on-single-page", "current-page", "page-size", "page-sizes", "layout", "total"]);
    };
  }
}), nl = { style: { padding: "20px", "background-color": "#fff" } }, rl = { class: "button_left" }, ul = /* @__PURE__ */ q(" \u65B0\u589E "), sl = /* @__PURE__ */ q(" \u6279\u91CF\u5220\u9664 "), dl = { class: "button_right" }, il = { style: { display: "flex", "justify-content": "flex-end" } }, pl = /* @__PURE__ */ q("\u53D6\u6D88"), cl = /* @__PURE__ */ q("\u91CD\u7F6E"), fl = /* @__PURE__ */ q("\u63D0\u4EA4"), _l = /* @__PURE__ */ _e({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    debug: { type: Boolean, default: () => R.debug },
    mainMaxHeight: { default: () => R.mainMaxHeight },
    isAfterMountQuery: { type: Boolean, default: () => R.isAfterMountQuery },
    isOpenSearchForm: { type: Boolean, default: () => R.isOpenSearchForm },
    Form_LabelWidth: { default: () => R.Form_LabelWidth },
    Dialog_Width: { default: () => R.Dialog_Width },
    Dialog_isFullscreen: { type: Boolean, default: () => R.Dialog_isFullscreen },
    Dialog_isCloseOnPressEscape: { type: Boolean, default: () => R.Dialog_isCloseOnPressEscape },
    Dialog_isCloseOnClickModal: { type: Boolean, default: () => R.Dialog_isCloseOnClickModal },
    Dialog_isFooterButton: { type: Boolean, default: () => R.Dialog_isFooterButton },
    Table_Attributes: null,
    Table_isOpenIndex: { type: Boolean, default: () => R.Table_isOpenIndex },
    Table_isOpenMultipleSelection: { type: Boolean, default: () => R.Table_isOpenMultipleSelection },
    Table_isOpenExpand: { type: Boolean, default: () => R.Table_isOpenExpand },
    Table_ExpandColumn: { default: () => R.Table_ExpandColumn },
    Page_PageSizes: { default: () => R.Page_PageSizes },
    Page_PageParams: { default: () => R.Page_PageParams },
    Page_Layout: { default: () => R.Page_Layout },
    Page_isHideOnSinglePage: { type: Boolean, default: () => R.Page_isHideOnSinglePage },
    ApiName: { default: () => R.ApiName },
    Permission: { default: () => R.Permission },
    Permissions: { default: () => R.Permissions }
  },
  setup(r) {
    const p = r, c = qe();
    Qe(p);
    const { queryRecord: b, addRecord: a, handleSubmit: C, deleteMulRecord: E } = Ve(), { CompRef: v, initSearchModel: S, Mode: w, DialogVisible: V, multipleSelection: N, submitLoading: x, DialogVisibleFooterButton: t } = O(), { isOpenSearchForm: n, Table_isOpenMultipleSelection: P, Dialog_Width: B, Dialog_isFullscreen: T, Dialog_isCloseOnPressEscape: ne, Dialog_isCloseOnClickModal: re, Permission: I, Permissions: X } = me();
    if (c.params.data) {
      ce("\u8DEF\u7531\u4F20\u53C2\uFF1A", c.params.data);
      let m = c.params.data, D = JSON.parse(m);
      S.value = Fe(S.value, D);
    }
    const W = $(), Y = $(), u = $(), F = $(), Q = $(0), h = $(0), Z = $(0), se = $(0);
    he(() => {
      v.value.containerDivRef = W.value, v.value.searchDivRef = Y.value, v.value.buttonDivRef = u.value, v.value.paginationDivRef = F.value, Q.value = W.value.offsetHeight - 40, h.value = v.value.searchDivRef.offsetHeight, Z.value = v.value.buttonDivRef.offsetHeight, se.value = v.value.paginationDivRef.offsetHeight, console.log(v.value);
    });
    const de = fe(() => {
      const m = $(Q.value - Z.value - se.value);
      return n.value ? m.value - h.value : m.value;
    }), ie = fe(() => {
      const m = $(document.documentElement.clientHeight);
      return T.value ? m.value - 54 - 62 - 2 : m.value - 54 - 62 - 2 - m.value * 0.15 - 50;
    });
    return (m, D) => {
      var l, y;
      const M = we("Auth");
      return i(), L("div", {
        ref_key: "containerDivRef",
        ref: W,
        style: { height: "100%" }
      }, [
        G("div", nl, [
          G("div", {
            ref_key: "searchDivRef",
            ref: Y
          }, [
            ve(s(Xe, null, {
              "search-form": o(() => [
                H(m.$slots, "search-form", {
                  CrudState: e(O)()
                }, void 0, !0)
              ]),
              "search-form-top": o(() => [
                H(m.$slots, "search-form-top", {
                  CrudState: e(O)()
                }, void 0, !0)
              ]),
              "search-form-bottom": o(() => [
                H(m.$slots, "search-form-bottom", {
                  CrudState: e(O)()
                }, void 0, !0)
              ]),
              _: 3
            }, 512), [
              [xe, e(n)]
            ])
          ], 512),
          G("div", {
            ref_key: "buttonDivRef",
            ref: u,
            class: "buttonDiv"
          }, [
            G("div", rl, [
              ve((i(), g(e(ee), {
                type: "primary",
                icon: "plus",
                onClick: e(a)
              }, {
                default: o(() => [
                  ul
                ]),
                _: 1
              }, 8, ["onClick"])), [
                [M, { Permissions: e(X), access: [(l = e(I)) == null ? void 0 : l.add] }]
              ]),
              e(P) ? ve((i(), g(e(ee), {
                key: 0,
                disabled: e(N).length <= 0,
                type: "danger",
                icon: "delete",
                onClick: e(E)
              }, {
                default: o(() => [
                  sl
                ]),
                _: 1
              }, 8, ["disabled", "onClick"])), [
                [M, { Permissions: e(X), access: [(y = e(I)) == null ? void 0 : y.remove] }]
              ]) : z("", !0),
              H(m.$slots, "button-left", {
                CrudState: e(O)()
              }, void 0, !0)
            ]),
            G("div", dl, [
              H(m.$slots, "button-right", {
                CrudState: e(O)()
              }, void 0, !0)
            ]),
            s(e(ze), { style: { "flex-shrink": "0", width: "150px" } }, {
              default: o(() => [
                s(e(ee), {
                  color: "#67c23a",
                  icon: "search",
                  onClick: e(b)
                }, null, 8, ["onClick"]),
                s(e(ee), {
                  color: "#e6a23c",
                  icon: "refresh",
                  onClick: D[0] || (D[0] = (f) => e(v).SearchFormRef.resetFields())
                }),
                s(e(ee), {
                  color: "#409eff",
                  icon: "expand",
                  onClick: D[1] || (D[1] = (f) => n.value = !e(n))
                })
              ]),
              _: 1
            })
          ], 512),
          s(al, { height: e(de) }, {
            "table-column": o(() => [
              H(m.$slots, "table-column", {
                CrudState: e(O)()
              }, void 0, !0)
            ]),
            "menu-top": o((f) => [
              H(m.$slots, "menu-top", {
                scope: f,
                CrudState: e(O)()
              }, void 0, !0)
            ]),
            "menu-bottom": o((f) => [
              H(m.$slots, "menu-bottom", {
                scope: f,
                CrudState: e(O)()
              }, void 0, !0)
            ]),
            _: 3
          }, 8, ["height"]),
          G("div", {
            ref_key: "paginationDivRef",
            ref: F,
            style: { "padding-top": "20px" }
          }, [
            s(tl)
          ], 512),
          s(e(Ke), {
            class: "DialogVisible",
            modelValue: e(V),
            "onUpdate:modelValue": D[5] || (D[5] = (f) => Le(V) ? V.value = f : null),
            title: e(w) === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: e(B),
            "close-on-press-escape": e(ne),
            fullscreen: e(T),
            "close-on-click-modal": e(re)
          }, Re({
            default: o(() => [
              s(ll, { height: e(ie) }, {
                "edit-form": o(() => [
                  H(m.$slots, "edit-form", {
                    CrudState: e(O)()
                  }, void 0, !0)
                ]),
                "edit-form-top": o(() => [
                  H(m.$slots, "edit-form-top", {
                    CrudState: e(O)()
                  }, void 0, !0)
                ]),
                "edit-form-bottom": o(() => [
                  H(m.$slots, "edit-form-bottom", {
                    CrudState: e(O)()
                  }, void 0, !0)
                ]),
                _: 3
              }, 8, ["height"])
            ]),
            _: 2
          }, [
            e(t) ? {
              name: "footer",
              fn: o(() => [
                G("div", il, [
                  H(m.$slots, "edit-form-footer", {}, void 0, !0),
                  s(e(ee), {
                    onClick: D[2] || (D[2] = (f) => V.value = !1)
                  }, {
                    default: o(() => [
                      pl
                    ]),
                    _: 1
                  }),
                  s(e(ee), {
                    type: "warning",
                    plain: "",
                    onClick: D[3] || (D[3] = (f) => e(v).EditFormRef.resetFields())
                  }, {
                    default: o(() => [
                      cl
                    ]),
                    _: 1
                  }),
                  s(e(ee), {
                    type: "primary",
                    loading: e(x),
                    onClick: D[4] || (D[4] = (f) => e(C)(e(v).EditFormRef))
                  }, {
                    default: o(() => [
                      fl
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "close-on-press-escape", "fullscreen", "close-on-click-modal"])
        ])
      ], 512);
    };
  }
});
const Pe = /* @__PURE__ */ Be(_l, [["__scopeId", "data-v-a5146ffb"]]), ml = {
  mounted(r, p, c) {
  }
};
Pe.install = (r) => {
  r.component("CrudEl", Pe), r.directive("Auth", ml);
};
const hl = (r, p) => {
  p ? (p.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), We(p), r.use(Pe)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  Fe as DataMerger,
  ae as DeepClone,
  We as InitSys,
  hl as createCrudEl,
  le as hooksName,
  Ie as isObjEqual,
  je as useHooks
};
